10 ';**********************************
20 ';*                                *
30 ';*    Programm: 8to24.bin         *
40 ';*            : August 1989       *
50 ';*                                *
60 ';*    Drucker-Treiber fuer        *
70 ';*    24-Nadel-Drucker            *
80 ';*                                *
90 ';**********************************
100 '
110 ';* Initialisierungs- und 
120 ';* Installationsteil,
130 ';* Aufruf vom BASIC:
140 ';* CALL LadeAdresse,LadeAdresse
150 '
160 'org &9000
170 '
180 'or a ;Parameter uebergeben?
190 'ret z ;nein -> zurueck
200 'ld l,(ix+0)
210 'ld h,(ix+1)
220 'push hl
230 'pop ix ;Lade-Adr. in ix
240 'ld bc,&1c9 ;Offset zu prchr
250 'push hl
260 'add hl,bc
270 'push hl
280 'pop bc ;bc=abs. Adresse v. prchr
290 'pop hl
300 'ld de,&5c ;Offs. zum HP-Beginn 
310 'add hl,de
320 'push hl
330 ' ;alle CALL prchr eintragen
340 'ld de,&4f ;Offset z. Ofsset-Tab.
350 'add ix,de ;ix=Pointer a. Tabelle
360 'ld d,0 ;High-Byte d. Offsets=0
370 'loop ld a,(ix)
380 'or a
390 'jr z,finish ;Alles eingetragen?
400 'ld e,a
410 'add hl,de
420 'ld (hl),c
430 'inc hl
440 'ld (hl),b
450 'inc ix
460 'jr loop
470 'finish ld de,&16 ;Offs. zu RST8 (PRCHR) 
480 'ld a,(&bd32) ;RST-Adr.in Rout. kop. 
490 'add hl,de
500 'ld (hl),a
510 'inc hl
520 'ld a,(&bd33)
530 'ld (hl),a
540 'pop bc
550 'ld hl,&bd31 ;Vektor MC SEND PR.   
560 'ld (hl),195 ;OPCODE JP nn
570 '
580 'inc hl
590 'ld (hl),c
600 'inc hl
610 'ld (hl),b
620 'ld hl,&bdf1 ;Vektor MC WAIT PR.
630 'ld (hl),195 ;OPCODE JP nn     
640 'inc hl  
650 'ld (hl),c 
660 'inc hl
670 'ld (hl),b
680 'ret
690 '
700 ' ;Offset-Tabelle:
710 'db &22,&b,&23,&1e,&17,&60,&5,&c,&1b,&6,&35,&5,&0
720 '
730 ';* Hauptprogramm Version p
740 '
750 ';*VARIABLE:
760 ';*(ix+0) : GMODE (ESC-Seq. liegt an)
770 ';*(ix+1) : GAKTIV (Flag-Grafik akt.)
780 ';*(ix+2) : ZAEHL1 (LB des Zaehlers)
790 ';*(ix+3) : ZAEHL2 (HB des Zaehlers)
800 ';*(ix+4) : MULTIP (Mehrfachdruck)
810 '
820 '
830 'push ix ;alle verwendeten Reg. retten
840 'push hl
850 'push de
860 'push bc
870 'push af
880 ';
890 'ld ix,(&bdf2) ;Adresse d. Prg-Beginns
900 'ld de,&175 ;Offset Prg. Anfang-Ende
910 'add ix,de ;Adresse d. 1. Var. in ix
920 '
930 'ld a,(ix+0) ;lag schon ESC-Seq. an?
940 'or a
950 'jr nz,zsteu
960 '
970 'ld a,(ix+1) ;noch Grafik-Daten?
980 'or a
990 'jr nz,convrt
1000 '
1010 'pop af
1020 'push af
1030 'cp 27 ;liegt ESC an?
1040 'jr nz,ausgab
1050 'pr1 call prchr
1060 'jr nc,pr1
1070 'ld a,4
1080 'ld (ix+0),a
1090 'jr ende1
1100 '
1110 'ausgab call prchr ;unkonvertierte Ausgabe
1120 'jr nc,ausgab
1130 'jr ende1
1140 '
1150 'zsteu jr steuer
1160 '
1170 ';Beginn Konvert.-Routine
1180 'convrt ld b,(ix+4) ;Anzahl Mehrf.-Druck
1190 'prloop pop af  
1200 'push af
1210 'ld e,b
1220 'ld d,a
1230 'xor a
1240 'rlc d
1250 'jr nc,rot2
1260 'or &e0
1270 'rot2 rlc d
1280 'jr nc,rot3
1290 'or &1c
1300 'rot3 rlc d
1310 'push af
1320 'jr nc,mc1
1330 'or 3
1340 'mc1 call prchr
1350 'jr nc,mc1
1360 'pop af
1370 'ld a,0
1380 'jr nc,rot4
1390 'or &80
1400 'rot4 rlc d
1410 'jr nc,rot5
1420 'or &70
1430 'rot5 rlc d
1440 'jr nc,rot6
1450 'or &e
1460 'rot6 rlc d
1470 'push af
1480 'jr nc,mc2
1490 'or 1
1500 'mc2 call prchr
1510 'jr nc,mc2
1520 'pop af
1530 'ld a,0
1540 'jr nc,rot7
1550 'or &c0
1560 'rot7 rlc d
1570 'jr nc,rot8
1580 'or &38
1590 'rot8 rlc d
1600 'jr nc,mc3
1610 'or 7
1620 'mc3 call prchr
1630 'jr nc,mc3
1640 'ld b,e
1650 'djnz prloop ;Schleife f. Mehrf.-Druck
1660 'ld l,(ix+2)
1670 'ld h,(ix+3)
1680 'dec hl ;dekr. d. Grafik-Zaehlers
1690 'ld (ix+2),l
1700 'ld (ix+3),h
1710 'ld a,h
1720 'or l
1730 'jr nz,ende1
1740 'ld (ix+1),a ;keine weiteren Grafik-Daten
1750 ';Ende Konvert.-Routine
1760 '
1770 'ende1 jr ende2
1780 '
1790 'steuer cp 4 ;weitere Untersuchung
1800 'jr nz,drei ;einer ESC-Sequenz
1810 'pop af
1820 'push af
1830 'cp "L"
1840 'jr z,dicht2
1850 'cp "Y"
1860 'jr z,dicht2
1870 'cp "K"
1880 'jr z,dicht1
1890 'cp "Z"
1900 'jr z,dicht4
1910 'cp "*"
1920 'jr nz,nograf ;kein Grafik-Druck
1930 'ld a,(ix+0)
1940 'dec a
1950 'ld (ix+0),a
1960 'jr ende2
1970 'dicht4 ld d,40  
1980 'ld (ix+4),1
1990 'jr ginit
2000 'dicht2 ld d,33
2010 'ld (ix+4),1
2020 'jr ginit
2030 'dicht1 ld d,32
2040 'ld (ix+4),1
2050 'ginit ld a,(ix+0)
2060 'dec a
2070 'dec a
2080 'ld (ix+0),a
2090 'ld a,"*"
2100 'pr2 call prchr
2110 'jr nc,pr2
2120 'ld a,d
2130 'pr3 call prchr
2140 'jr nc,pr3
2150 'jr ende
2160 'nograf xor a
2170 'ld (ix+0),a
2180 'pop af
2190 'push af
2200 'pr4 call prchr
2210 'jr nc,pr4
2220 'ende2 jr ende
2230 'drei cp 3 
2240 'jr nz,zwei
2250 'inc a
2260 'ld (ix+0),a
2270 'pop af
2280 'push af
2290 'or a
2300 'jr z,dicht1
2310 'cp 3
2320 'jr c,dicht2
2330 'jr z,dicht4
2340 'ld a,"*"
2350 'pr7 call prchr
2360 'jr nc,pr7
2370 'pop af
2380 'push af
2390 'pr8 call prchr
2400 'jr nc,pr8
2410 'xor a
2420 'ld (ix+0),a
2430 'jr ende
2440 'zwei cp 2 
2450 'jr nz,gron
2460 'ld a,(ix+0)
2470 'dec a
2480 'ld (ix+0),a
2490 'pop af
2500 'push af
2510 'ld (ix+2),a
2520 'jr ende
2530 '
2540 'gron xor a ;Grafik aktiv schalten
2550 'ld (ix+0),a
2560 'pop af
2570 'push af
2580 'ld (ix+3),a
2590 'ld hl,0
2600 'ld e,(ix+2)
2610 'ld d,(ix+3)
2620 'ld b,(ix+4)
2630 'adloop add hl,de
2640 'djnz adloop
2650 'ld a,l
2660 'pr5 call prchr 
2670 'jr nc,pr5
2680 'ld a,h
2690 'pr6 call prchr
2700 'jr nc,pr6
2710 'ld a,1
2720 'ld (ix+1),a
2730 '
2740 'ende pop af ;alle Reg. restaurieren
2750 'pop bc
2760 'pop de
2770 'pop hl
2780 'pop ix
2790 'scf
2800 'ret
2810 '
2820 ';Drucker-Ausgabe-UP
2830 'prchr call &bd2e ;MC BUSY PRINTER
2840 'jr c,prchr
2850 'rst 8 ;MC SEND PRINTER
2860 'db 0,0 ;<- wird von Init. eingetragen
2870 '
2880 'gmode db 0
2890 'gaktiv db 0
2900 'zaehl1 db 0
2910 'zaehl2 db 0
2920 'multip db 1

